#pragma once

#include <f8/protoutils.h>

//game client listener
namespace a8
{
    class TcpListener;
}

class GGListener : public a8::Singleton<GGListener>
{
 private:
    GGListener() {};
    friend class a8::Singleton<GGListener>;

 public:
    void Init();
    void UnInit();

    template <typename T>
    void SendMsg(int sockhandle, T& msg)
    {
        static int msgid = f8::Net_GetMessageId(msg);
        f8::Net_SendMsg(tcp_listener_.get(), sockhandle, 0, msgid, msg);
    }

    void SendText(int sockhandle, const std::string& text);

    void ForceCloseClient(int sockhandle);
    void MarkClient(int sockhandle, bool is_active);

 private:
    std::shared_ptr<a8::TcpListener> tcp_listener_;
};
