#include "precompile.h"

#include <f8/utils.h>

#include "jsondatamgr.h"
#include "app.h"

void JsonDataMgr::Init()
{
    if (!f8::IsOnlineEnv()) {
        if (f8::IsTestEnv()) {
            work_path_ = a8::Format("../%d_test_config", {App::Instance()->GetGameId()});
        } else {
            work_path_ = a8::Format("../%d_dev_config", {App::Instance()->GetGameId()});
        }
    }

    std::string masterserver_cluster_json_file = a8::Format
        ("%s/zone%d/node%d/masterserver.cluster.json",
         {
          work_path_,
          f8::App::Instance()->GetZoneId(),
          f8::App::Instance()->GetNodeId(),
         });
    masterserver_cluster_json_.ReadFromFile(masterserver_cluster_json_file);
}

void JsonDataMgr::UnInit()
{
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetConf()
{
    for (int i = 0; i < masterserver_cluster_json_.Size(); ++i) {
        auto conf = masterserver_cluster_json_.At(i);
        if (conf->At("instance_id")->AsXValue().GetInt() == f8::App::Instance()->GetInstanceId()) {
            return conf;
        }
    }
    A8_ABORT();
}
